<template>
    <div class="coinCards " :class="{'desable' : isCoinsDisabled}" >
        <div v-for="coin in coinsCards" :key="coin.symbol" :id="coin.symbol" @click="isSelectedChange(coin), routerChange(coin), daysPriceArr=[]" :className="'row coinCard card ' + (coin.isSelected? 'selected' : '')">
            <div class="row mainRow">
                <div :className="'logo row ' + coin.symbol" ><img v-if="coin.logourl" :src="coin.logourl" alt=""></div>
                <div class="row prise">$ <div :className="'currentPrice ' + coin.difference"> {{coin.currentPrice}}</div></div>
            </div>
            <div class="fav-selector" @click.stop="addToFav(coin)">
                <div class="fav-icon " 
                :class="{
                    'fav':  coin.isFav,
                    'no-fav': !coin.isFav  
                }"></div>
            </div>
            <div v-if="coin.isSelected" class="graphBtn">
                <button  class=""  @click.stop="getDeysPriceArr(coin.symbol)"><div>last 30 days</div></button>
                <button  class="" ><div>last 24 hours</div></button>
                <button  class="" @click.stop="realTimePricesOn=!realTimePricesOn,  daysPriceArr=[]"><div>real time changes</div></button>              
                <div v-if="daysPriceArr.length || realTimePricesOn" class="minus row">
                    <div v-if="daysPriceArr.length" class="graph days row">
                        <div v-for="(day, indx) in daysPriceArr" :key="indx" class="dayValue" 
                            :class="{
                                'up': day.difference > 0,
                                'down': day.difference < 0  
                            }" 
                            :style=" day.difference > 0 ? { 
                                    height: `${day.absChange}%`,
                                    marginBottom: `${day.margin*2}px`
                                } : {
                                    height: `${day.absChange}%`,
                                    marginBottom: `${(day.margin - day.absChange)*2}px`
                                }">
                        </div>
                    </div>
                    <div v-if="realTimePricesOn" class="graph real-time row">
                        <div v-for="(change, indx) in getRealTimePrices" :key="indx" class="dayValue" 
                            :class="{
                                'up': change.difference > 0,
                                'down': change.difference < 0  
                            }" 
                            :style=" change.difference > 0 ? { 
                                    height: `${change.absChange}%`,
                                    marginBottom: `${change.margin*2}px`
                                } : {
                                    height: `${change.absChange}%`,
                                    marginBottom: `${(change.margin - change.absChange)*2}px`
                                }">
                        </div>
                    </div>
                </div>
            </div>
        </div>
    </div>
</template>

<script>
    import {getGraphValues} from './getGraphValues'
    import { mapGetters, mapMutations, mapActions } from 'vuex';
    import axios from 'axios';
    export default {
        data() {
            return {
                realTimePricesOn: false,
                realTimePrices: [],
                daysPriceArr: [],
                minPrice: null,
                maxPrice: null
            }
        },
        methods: {
            ...mapActions(['getPrices']),
            ...mapMutations(['isSelectedChange', 'addToFav', 'getFavList']),
            async getDeysPriceArr(symbol) {
                const resp = await axios.get(`https://min-api.cryptocompare.com/data/v2/histoday?fsym=${symbol}&tsym=USD&limit=30&api_key=e86ad2b821b4fe0801179ebfa7e33be649f35bdfc77c6695eaa29c37a029cc71`)
                const tempArr = resp.data.Data.Data
                const data = []
                for (let item of tempArr) {
                    data.push(item.close)
                }
                this.daysPriceArr = getGraphValues(data) 
            },
            routerChange(coin) {
                const router = this.$router
                router.push(coin.symbol.toLowerCase())
            },
        },
        computed: {
            ...mapGetters(['coinsCards', 'isCoinsDisabled']),

/*             getRealTimePrices() {
                let graphValues = []
                for (let coin of this.coinsArr) {
                    graphValues.push()
                    if (coin.pricesArr.length > 1) {
                        let pushValue = getGraphValues(coin.pricesArr)
                        graphValues.push(pushValue)
                    }
                }
                console.log(graphValues)
                return graphValues
            } */
        },
        
        async mounted() {
            this.getFavList()
            this.getPrices(this.coinsCards)
            this.coinInterval = setInterval(() => {
                    this.getPrices(this.coinsCards)
            }, 10000);
        },
        beforeUnmount() { clearInterval(this.coinInterval) },
        }
</script>

<style scoped>
.coinCards {
    display: flex;
    flex-direction: column;
    width: 1240px;
    gap: 10px;  
}
.desable {
    width: 300px;
}

    .currentPrice {
        border-radius: 5px; 
        width: 170px;
        height: 32px;
        align-self: center;
        text-align: center;
    }
    .coinCard {
        padding: 15px;
        height: 50px;
        font-size: 28px;
        justify-content: space-between;
        transition: width .3s ease;
        width: 400px
    }
    .mainRow {
        gap: 120px;
    }
    .desable .coinCard {
        width: 300px;
    }
    .desable .mainRow {
        gap: 20px;
    }
    .logo{
        align-items: center;
    }
    .logo img {
        width: 50px;
        height: 50px;
    }
    .up {
        background-color: green;
        transition: all .2s;
    }
    .down {
        background-color: red;
        transition: all .2s;
    }
    .graph {
        height: 200px;
        width: auto;
        background: grey;
        align-items: end;
    }
    .minus {
        position: absolute;
        margin: 35px -198px;
        width: auto;
        padding-inline: 30px;
        height: 400px;
        z-index: -1;
        background: grey;
    }
    .dayValue {
        width: 15px;
    }
    .fav-icon {
        width: 30px;
        height: 30px;
        background-position: center;
        background-size: contain;
        background-repeat: no-repeat;
    }
    .fav {
        background-image: url(@/icon/favorite.png);
        transition: .3s;
    }
    .no-fav {
        background-image: url(@/icon/nofavorite.png);
        transition: .3s;
    }
</style>